<?php
namespace nur\b\coll;

use Iterator;

/**
 * Class IterableArray: implémentation de base d'un tableau iterable
 *
 * les classes dérivées *doivent* implémenter les méthodes key() et current()
 * qui peuvent simplement être implémentée comme des méthodes déléguées de
 * respectivement {@link _key()} et {@link _current()}.
 *
 * Ce mode opératoire permet de créer ces méthodes avec une signature appropriée,
 * permettant à un IDE de découvrir le type des données qui sont accédées
 */
abstract class IterableArray extends BaseArray implements Iterator {
  use TIterableArray;
}
